package nl.hackerstore.wwswitch;

import nl.m4rc3lv.pcschakelaar.R;

import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.BasicResponseHandler;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends Activity {
 MainActivity zelf;
 static Integer Token;

 @Override
 protected void onCreate(Bundle savedInstanceState) {
  super.onCreate(savedInstanceState);
  setContentView(R.layout.activity_main);
  zelf = this;
  Status();
 }

 @Override
 public boolean onCreateOptionsMenu(Menu menu) {
  // Inflate the menu; this adds items to the action bar if it is present.
  getMenuInflater().inflate(R.menu.main, menu);
  return true;
 }

 private class Schakelaar extends AsyncTask<String, Void, String> {
  ProgressDialog progress;

  @Override
  protected void onPreExecute() {
   progress = new ProgressDialog(zelf);
   progress.setTitle("Internet...");
   progress.setMessage(getString(R.string.connecting));
   progress.show();
   super.onPreExecute();
  }

  @Override
  protected String doInBackground(String... uri) {
   try {
    HttpClient httpClient = new DefaultHttpClient();
    HttpGet get = new HttpGet(uri[0]);

    String s = httpClient.execute(get, new BasicResponseHandler());
    return s;
   }
   catch (Exception e) {
    return "Network error";
   }
  }

  protected void onPostExecute(String result) {
   try {
    progress.dismiss();
    String status = result.split("\\-")[1].trim();
    String code = result.split("\\-")[0].trim();
    Token = Integer.parseInt(code);
    ((TextView) findViewById(R.id.txtStatus)).setText("Status: " + status);
   }
   catch (Exception a) {
    ((TextView) findViewById(R.id.txtStatus)).setText("Status: ERROR");
   }
  }
 }

 void Status() {
  SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(MainActivity.this);
  String uri = "http://" + prefs.getString("ip", "192.168.0.88") + ":8080";
  new Schakelaar().execute(uri);
 }

 Integer Hash() {
  return (Token << 3) + 3; // Same hash function as in the arduino sketch
 }

 public void kliKAan(View v) {
  SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(MainActivity.this);
  String uri = "http://" + prefs.getString("ip", "192.168.0.88") + ":8080/aan"+Hash().toString();
  new Schakelaar().execute(uri);
 }
 
 public void kliKUit(View v) {
  SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(MainActivity.this);
  String uri = "http://" + prefs.getString("ip", "192.168.0.88") + ":8080/uit"+Hash().toString();
  new Schakelaar().execute(uri);
 }

 @Override
 public boolean onOptionsItemSelected(MenuItem item) {
  int id = item.getItemId();
  if(id == R.id.action_settings) {
   Intent intent = new Intent(MainActivity.this, Instellingen.class);
   startActivity(intent);
   return true;
  }
  return super.onOptionsItemSelected(item);
 }
}
